using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Microsoft.VisualStudio.TestTools.WebTesting;
using Microsoft.VisualStudio.TestTools.WebTesting.Rules;

using HtmlAgilityPack;

namespace ExtractTextArea
{
    public class ExtractTextAreaRule : ExtractionRule
    {
        string _name;
        
        [Description("The name of the text field to extract.")]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public override void Extract(object sender, ExtractionEventArgs e)
        {                   
            HtmlAgilityPack.HtmlDocument document = new HtmlAgilityPack.HtmlDocument();

            document.LoadHtml(e.Response.BodyString);

            HtmlNode textArea = document.GetElementbyId(_name);

            if (textArea != null)
            {
                e.WebTest.Context.Add(this.ContextParameterName, textArea.InnerHtml);                
            }
        }

        public override string RuleName
        {
            get { return "Extract TextArea"; }
        }
    }
}
