Imports Microsoft.VisualStudio.TestTools.WebTesting
Imports Microsoft.VisualStudio.TestTools.WebTesting.Rules
Imports HtmlAgilityPack

Public Class ExtractTextAreaRule
    Inherits ExtractionRule

    Private ElementName As String

    <ComponentModel.Description("The name of the text field to extract.")> _
    Public Property Name() As String
        Get
            Return ElementName
        End Get
        Set(ByVal value As String)
            ElementName = value
        End Set
    End Property

    Public Overrides Sub Extract(ByVal sender As Object, ByVal e As Microsoft.VisualStudio.TestTools.WebTesting.ExtractionEventArgs)

        Dim document As New HtmlAgilityPack.HtmlDocument()

        document.LoadHtml(e.Response.BodyString)

        Dim textArea As HtmlNode

        textArea = document.GetElementbyId(ElementName)

        If (textArea Is Nothing) Then
        Else
            e.WebTest.Context.Add(Me.ContextParameterName, textArea.InnerHtml)
        End If

    End Sub
        
    Public Overrides ReadOnly Property RuleName() As String
        Get
            Return "Extract TextArea"
        End Get
    End Property
        
End Class
